/* -*- C++ -*-
*
* ---------------------------------------------------------------------
* $Id: testmarrayio.cpp 363 2008-07-10 15:09:44Z drory $
* ---------------------------------------------------------------------
*
* Copyright (C)  Jan Snigula <snigula@usm.uni-muenchen.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
*
* ---------------------------------------------------------------------
*
*/

#define LTL_RANGE_CHECKING

#include <fstream>

#include <ltl/marray.h>
#include <ltl/marray_io.h>
#include <ltl/fvector.h>
#include <ltl/statistics.h>

using namespace ltl;
using namespace std;

using std::cout;
using std::endl;

int main(int argc, char **argv)
{
   MArray<float,1> A(10);
   MArray<float,1> B(10);
   A = 0,1,2,3,4,5,6,7,8,9;
   B = 0;
   ofstream os( "testmarrayio.dat" );
   os << A << endl;
   os.close();
   
   ifstream is( "testmarrayio.dat" );
   is >> B;
   is.close();
   LTL_ASSERT_( allof(A == B),
                "MArray stream io failed" );
   

   FVector<float,3> X;
   FVector<float,3> Y;
   X = 0,1,2;
   Y = 0;
   ofstream os2( "testmarrayio.dat" );
   os2 << X << endl;
   os2.close();
   
   ifstream is2( "testmarrayio.dat" );
   is2 >> Y;
   LTL_ASSERT_( X(1) == Y(1) && X(2) == Y(2) && X(3) == Y(3),
                "FVector stream io failed" );
}

